/*
 * LogTxt.cpp
 *
 *  Created on: May 15, 2014
 *      Author: siriholt
 */

// DUNE headers.
#include <DUNE/Config.hpp>
#include <DUNE/LogUtilities/LogTxt.hpp>
#include <DUNE/DUNE.hpp>

#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <stdlib.h>
#include <time.h>

namespace DUNE
{
  namespace LogUtilities
  {
  	  using DUNE_NAMESPACES;

	  LogTxt::LogTxt() {
		// TODO Auto-generated constructor stub
		start_time = time(0);
		char time[80];
		struct tm tstruct;
		tstruct = *localtime(&start_time);
		strcpy(filename, "/home/simen/Dropbox/log/");
		strftime(time, sizeof(time), "%Y-%m-%d.%X", &tstruct);
		strcat(filename, time);
		std::cout << "Made filename " << filename << '\n';
	  }

	  LogTxt::~LogTxt() {
		// TODO Auto-generated destructor stub
	  }

	  void LogTxt::log_start_distance_from_target()
	  {
		strcat(filename,"_dist_");
		strcat(filename, ".txt");
		myFile.open(filename, std::ios::app);
		if(!myFile.is_open())
		{
			std::cout << "error opening file" << filename << '\n';
		  return;
		}
		myFile << "Recording Distance from Target" << "\n";
		myFile << "method" << '\t' << "dist:" << '\t' << "distX:"
				<< '\t' << "distY:" << '\n';
		myFile << "-------------------------" << '\n';
		myFile.close();
		std::cout << "Successful opening of file!";
	  }

	  void LogTxt::log_start_deviation_from_ideal()
	  {
		strcat(filename,"_deviation_");
		strcat(filename, ".txt");
		myFile.open(filename, std::ios::app);
		if(!myFile.is_open())
		{
			std::cout << "error opening file" << filename << '\n';
		  return;
		}
		myFile << "Recording Deviation from Ideal Position" << "\n";
		myFile << "method"
				<< '\t' << "distX" << '\t' << "distY" << '\t' << "distZ" << '\t' << "distTot"
				<< '\t' << "velX" << '\t' << "velY" << '\t' << "velZ"
				<< '\t' << "idealVelX" << '\t' << "idealVelY" << '\t' << "idealVelz"
				<< '\t' << '\n';
		myFile << "-------------------------" << '\n';
		myFile.close();
	  }

	  void LogTxt::log_start_info()
	  {
		strcat(filename,"_info_");
		strcat(filename, ".txt");
		myFile.open(filename, std::ios::app);
		if(!myFile.is_open())
		{
			std::cout << "error opening file" << filename << '\n';
		  return;
		}
		myFile << "Recording All Info" << "\n";
		myFile << "hit" << '\t' << "dist" << '\t' << "distx" << '\t' << "disty" << '\t'
			  << "rcog" << '\t' << "arcog" << '\t'
			  << "u" << '\t' << "v" << '\t' << "w" << '\t'
			  << "vx" << '\t' << "vy" << '\t' << "vz" << '\t'
			  << "x" << '\t' << "y" << '\t' << "height" << '\t'
			  << "lat" << '\t' << "lon" << '\t'
			  << "alt" << '\n';
		myFile << "--------------------------------------------------------------------------------------------------------------" << '\n';
		myFile.close();
	  }

	  void LogTxt::log_start_latitude_longitude_altitude()
	  {
		strcat(filename,"_latlon_");
		strcat(filename, ".txt");
		myFile.open(filename, std::ios::app);
		if(!myFile.is_open())
		{
			std::cout << "error opening file" << filename << '\n';
		  return;
		}
		myFile << "Recording Latitude, Longitude and Altitude" << "\n";
		myFile << "method"
				<< '\t' << "Lat" << '\t' << "Lon" << '\t' << "Alt" << '\n';
		myFile << "-------------------------" << '\n';
		myFile.close();
	  }

	  void LogTxt::log_latitude_longitude_altitude(double lat, double lon, double alt)
	  {
		  myFile.open(filename, std::ios::app);
		if(!myFile.is_open())
		{
			std::cout << "error opening file" << filename << '\n';
			return;
		}
		myFile << std::fixed << std::setprecision(10)
		<< '\t' << lat << '\t' << lon << '\t' << alt<< '\n';
		myFile.close();
	  }

	  void LogTxt::log_distance_from_target(IMC::TrajectoryPoint current,
			  IMC::TrajectoryPoint target, std::string method)
	  {
	  	double dist_x = target.x - current.x;
	  	double dist_y = target.y - current.y;
	  	double dist = sqrt(dist_x*dist_x + dist_y*dist_y);
	  	myFile.open(filename, std::ios::app);
		if(!myFile.is_open())
		{
			std::cout << "error opening file" << filename << '\n';
		  return;
		}
	  	myFile << std::fixed << std::setprecision(10) << method
	  		<< '\t' << dist << '\t' << dist_x << '\t' << dist_y << '\n';
	  	myFile.close();
	  }

	  void LogTxt::log_deviation_from_ideal(IMC::TrajectoryPoint current,
			  IMC::TrajectoryPoint target, std::string method, double m_wind_x,
			  double m_wind_y, double m_wind_z, double m_vx, double m_vy, double m_vz)
	  {
		double dist_x = target.x - current.x;
		double dist_y = target.y - current.y;
		double dist_z = target.z - current.z;
		double dist = sqrt(dist_x*dist_x + dist_y*dist_y);
		double idealVelX = -m_wind_x;
		double idealVelY = -m_wind_y;
		double idealVelZ = -m_wind_z;
		myFile.open(filename, std::ios::app);
		if(!myFile.is_open())
		{
			std::cout << "error opening file" << filename << '\n';
		  return;
		}
		myFile << std::fixed << std::setprecision(10) << method
				<< '\t' << dist_x << '\t' << dist_y << '\t' << dist_z << '\t' << dist
				<< '\t' << m_vx << '\t' << m_vy << '\t' << m_vz
				<< '\t' << idealVelX << '\t' << idealVelY << '\t' << idealVelZ
				<< '\t' << '\n';
		myFile << "-------------------------" << '\n';
		myFile.close();
	  }

  }
}

