/*
 * LogTxt.h
 *
 *  Created on: May 15, 2014
 *      Author: siriholt
 */

#ifndef DUNE_TIME_LOGTXT_HPP_INCLUDED_
#define DUNE_TIME_LOGTXT_HPP_INCLUDED_

// DUNE headers.
#include <DUNE/Config.hpp>
#include <DUNE/Tasks/Context.hpp>
#include <DUNE/IMC.hpp>

#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <stdlib.h>
#include <time.h>

namespace DUNE
{
  namespace LogUtilities
  {
    // Export DLL Symbol.
    class DUNE_DLL_SYM LogTxt;

    //! %System clock routines.
    class LogTxt {
    private:
    	char filename[256];
    	std::ofstream myFile;
    	time_t start_time;
    	FileSystem::Path dir_app;
    public:
    	LogTxt();
    	virtual ~LogTxt();
    	void setFilename(std::string filename);
    	std::string getFilename();
    	void log_start_distance_from_target();
    	void log_start_deviation_from_ideal();
    	void log_start_info();
    	void log_start_latitude_longitude_altitude();
    	void log_latitude_longitude_altitude(double lat, double lon, double alt);
    	void log_distance_from_target(IMC::TrajectoryPoint current,
    			IMC::TrajectoryPoint target, std::string method);
    	void log_deviation_from_ideal(IMC::TrajectoryPoint current,
  			  IMC::TrajectoryPoint target, std::string method, double m_wind_x,
  			  double m_wind_y, double m_wind_z, double m_vx, double m_vy, double m_vz);
    };
  }
}

#endif
