//***************************************************************************
// Copyright 2007-2014 Universidade do Porto - Faculdade de Engenharia      *
// Laboratório de Sistemas e Tecnologia Subaquática (LSTS)                  *
//***************************************************************************
// This file is part of DUNE: Unified Navigation Environment.               *
//                                                                          *
// Commercial Licence Usage                                                 *
// Licencees holding valid commercial DUNE licences may use this file in    *
// accordance with the commercial licence agreement provided with the       *
// Software or, alternatively, in accordance with the terms contained in a  *
// written agreement between you and Universidade do Porto. For licensing   *
// terms, conditions, and further information contact lsts@fe.up.pt.        *
//                                                                          *
// European Union Public Licence - EUPL v.1.1 Usage                         *
// Alternatively, this file may be used under the terms of the EUPL,        *
// Version 1.1 only (the "Licence"), appearing in the file LICENCE.md       *
// included in the packaging of this file. You may not use this work        *
// except in compliance with the Licence. Unless required by applicable     *
// law or agreed to in writing, software distributed under the Licence is   *
// distributed on an "AS IS" basis, WITHOUT WARRANTIES OR CONDITIONS OF     *
// ANY KIND, either express or implied. See the Licence for the specific    *
// language governing permissions and limitations at                        *
// https://www.lsts.pt/dune/licence.                                        *
//***************************************************************************
// Author: Simen Fuglaas                                                    *
//***************************************************************************

#ifndef DUNE_RELEASECONFIG_HPP_INCLUDED_
#define DUNE_RELEASECONFIG_HPP_INCLUDED_

namespace DUNE
{
  //! %Calculates configuration (position and orientation of vehicle) upon release of payload
  //! %More specifically the ReleaseConfiguration class returns the release position and a vector associated with the wind
  namespace ReleasePayloadConfiguration
  { }
}

#include <DUNE/ReleasePayloadConfiguration/ReleaseConfiguration.hpp>
#include <DUNE/ReleasePayloadConfiguration/ReleaseVelocity.hpp>
#include <DUNE/ReleasePayloadConfiguration/ReleasePoint.hpp>
//#include "typedef.h"

#endif
