#ifndef RELEASE_CONF_H
#define RELEASE_CONF_H

#include "typedef.h"

class ReleaseVelocity;
class ReleasePoint;

class ReleaseConfiguration
{
private:
	double alt;
	double IAS;
	state_type wind;
	state_type release_point;
	state_type release_vel;
	position target;

	ReleaseVelocity * direction;
	ReleasePoint * point;

public:
	ReleaseConfiguration(double release_alt, state_type wind_vector, double indicated_air_speed, position target_pos);
	void setWind();
	void calc_point_of_release( );
	state_type get_release_point( );
};

#endif
