#ifndef RELEASE_POINT_H
#define RELEASE_POINT_H

#include "typedef.h"


class ReleasePoint
{
private:
	state_type wind;
	state_type x;
	double target_x;
	double target_y;
	double A;
	double b;
	double dt;
	static const double pi;
	static const double r;
	static const double m;
	static const double C_D;
	static const double rho;
	static const double g;

public:
	ReleasePoint( state_type wind_input , state_type x_input , double delta_time);
	state_type calc_release_point( double altitude );
	state_type get_release_point( );
	void operator()( const state_type &x , state_type &dxdt , double t );
	void operator()( const state_type &x , const double t );
};

#endif
