#ifndef RELEASE_VEL_H
#define RELEASE_VEL_H

#include "typedef.h"

class ReleaseVelocity
{
private:
	state_type wind;
	state_type release_velocity;
	state_type wind_unit_vector;
	double release_velocity_x;
	double release_velocity_y;
	double release_velocity_z;

	double wind_unit_x;
	double wind_unit_y;
	double wind_unit_z;

	double wind_magnitude;
	double IAS;

public:
	ReleaseVelocity( state_type wind_input , int indicated_air_speed );
	void calc_wind_unit( );
	void create_wind_unit_vector( );
	void calc_release_velocity_decomposed( );
	state_type calc_release_velocity( );
	state_type get_wind_unit_vector( );
	double get_wind_magnitude( );
};

#endif
