#ifndef GEN_AUG_DUBINS_H
#define GEN_AUG_DUBINS_H

#include "../typedef.h"
#include <list>

class GenerateAugDubins
{
private:
	bool cw;
	position c1;
	position c2;
	position c3;
	halfplane H1;
	halfplane H2;
	halfplane H3;
	halfplane H4;
	halfplane H5;
	halfplane H6;
	halfplane H1_DR;
	halfplane H2_DR;
	halfplane H3_DR;
	halfplane H4_DR;
	std::list< halfplane > halfplane_list;
	std::list< halfplane > halfplane_list2;
	double R;
	rot_matrix R_z;
	position ref;
	double max_bank_angle_rad;
	static const double pi;
	static const double g;
	static const double max_bank_angle_deg;

public:
	GenerateAugDubins(bool clockwise, double IAS, double wind, position target, state_type release_point, double displacedCircleDist, position ref_ned_frame);
	void deg2rad( );
	void calcRotMatrix(bool clockwise);
	void calculateRadius(double IAS, double wind);
	void findCircleCenters(position target, state_type release_point, double length);
	void calculateDubinsPath(position start_circle, position end_circle, halfplane &H1, halfplane &H2);
	void findHalfplanes();
	position NEDtoWGS84(double x, double y);
	std::list< halfplane > * getHalfplanes();
	double getRadius();

	void findHalfplanesDirectRoute();
	std::list< halfplane > * getHalfplanesDR();
};

#endif
