#ifndef WAYPOINT_GEN_H
#define WAYPOINT_GEN_H

#include "../typedef.h"

class WaypointGenerator
{
private:
	waypoint pre_release;
	waypoint release_point;
	waypoint post_release;
	waypointlist wpl;
	waypointlist wpl_wgs84;
	state_type wind_unit_vector;
	double ref_lat;
	double ref_lon;
	double ref_alt;
	double lat;
	double lon;
	double TAS;
	double max_turn_radius;
	double max_bank_angle_rad;



public:

	static const double pi;
	static const double max_bank_angle_deg;
	static const double g;
	static const double shift_const;

	WaypointGenerator( state_type release_point , double true_air_speed_input , waypoint ref_ned_frame );
	void deg2rad( );
	void calc_max_turn_radius( );
	void generate_pre_release_wp( );
	void generate_post_release_wp( );
	void generate_wp_list( );
	void generate_wp_list_wgs84( );
	waypointlist get_wp_list( );
	waypointlist get_wp_list_wgs84( );

};

#endif
