clear all;
close all;
clc;

format long;

% Set path
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\Log\StraightLineApproach')
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\')

% Extract file
filename = '2014-05-18.19_18_32_deviation_.txt';
data = extractDist( filename );

% Create sample vector
n = 1:length(data);

direction = zeros(length(data),1);
speed = zeros(length(data),1);

for i = n
    speed(i) = sqrt(data(i,5)^2 + data(i,6)^2 + data(i,7)^2);
    direction(i) = atan(data(i,6)/data(i,5))-atan(data(i,9)/data(i,8));
    direction(i) = direction(i)/pi*180;
end
    


%% Plot Dubins Path long time test

% Distance
figure
    
    subplot(3,1,1)
        h1 = plot(n, data(:,1),'LineWidth', 2);
        title(sprintf('Distance from PoR'))
        ylabel('Distance, x [m]')
    subplot(3,1,2)
        h1 = plot(n, data(:,2),'LineWidth', 2);
        ylabel('Distance, y [m]')
    subplot(3,1,3)
        h1 = plot(n, data(:,4),'LineWidth', 2);
        ylabel(sprintf('Total horizontal\ndistance [m]'))
        xlabel('Samples')
        
% Direction
figure
    plot(n, direction(:),'LineWidth', 2)
    xlabel('Samples')
    ylabel('Angle [deg]')
    title('Deviation from desired angle')
    
% Speed
figure
    plot(n, speed(:),'LineWidth', 2)