clear all;
close all;
clc;

format long;

% Set path
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\Log\Dubins Path')
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\')

% Extract first file
filename = '2014-05-19.10_22_56_deviation_.txt';
data_1 = extractDist( filename );

% Extract second file
filename = '2014-05-19.17_29_51_deviation_.txt';
data_2 = extractDist( filename );

% Merge data
data = [data_1; data_2];

% Create sample vector
n = 1:length(data);

direction = zeros(length(data),1);
speed = zeros(length(data),1);

for i = n
    speed(i) = sqrt(data(i,5)^2 + data(i,6)^2 + data(i,7)^2);
    direction(i) = atan(data(i,6)/data(i,5))-atan(data(i,9)/data(i,8));
    direction(i) = direction(i)/pi*180;
end
    
%% Plot Dubins Path long time test

% Distance
figure
    
    subplot(3,1,1)
        h1 = plot(n, data(:,1),'LineWidth', 2);
        title(sprintf('Distance from PoR'))
        ylabel('x [m]')
    subplot(3,1,2)
        h1 = plot(n, data(:,2),'LineWidth', 2);
        ylabel('y [m]')
    subplot(3,1,3)
        h1 = plot(n, data(:,4),'LineWidth', 2);
        ylabel(sprintf('Total horizontal\ndistance [m]'))
        xlabel('Logged Samples')
        set(gcf,'color','w');
        export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\Approach_configuration_Dubins_Distance.eps');
        
% Direction
[muhat,sigmahat] = normfit(direction);

Y = normpdf(-1:0.01:1, muhat, sigmahat );

figure
    plot(-1:0.01:1, Y, 'LineWidth', 2)
    title('Estimated Normal Distribution of the deviation from the desired angle')
    xlabel('Angle [deg]')
    ylabel('Probability density, p(Angle)')
    text(0.5,2.5,'$\hat{\mu}$','Interpreter','latex')
    text(0.55,2.5,sprintf('= %f', muhat))
    text(0.5,2.3,'$\hat{\sigma}$','Interpreter','latex')
    text(0.55,2.3,sprintf('= %f', sigmahat))
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\Approach_configuration_Dubins_Direction.eps');

    
figure
    plot(n, direction(:),'LineWidth', 2)
    title('Deviation from desired angle of approach')
    xlabel('Samples')
    ylabel('Angle (deg)')
   
    
% % Speed
% figure
%     plot(n, speed(:))