clear all;
close all;
clc;

format long;

% Set path
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\Log\WindTest')
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\')

%% Dubins Path wind = 0 m/s
figure

    filename = 'DubinsNoWind12014-05-20.08_13_29_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'DubinsNoWind22014-05-20.08_16_51_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'DubinsNoWind32014-05-20.08_19_35_latlon_.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    axis image
    
    legend([h4 h5], 'Start', 'End', 'Location','best');
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Augmented Dubins Path without wind')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
%     axis('square')
%    axis([-122.368 -122.358 37.642 37.658])

    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\DubinsGeoPos_wind_0.eps');

    
%% Dubins Path wind = 5 m/s
figure

    filename = 'Dubins5MPSWindSouth12014-05-20.08_49_32_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'Dubins5MPSWindSouth22014-05-20.08_53_10_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    legend([h4 h5], 'Start', 'End', 'Location','best');
    
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Augmented Dubins Path with 5 m/s wind (south)')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\DubinsGeoPos_wind_5.eps');


%% Dubins Path wind = 10 m/s
figure

    filename = 'Dubins10MPSWindSouth12014-05-20.09_05_11_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'Dubins10MPSWindSouth22014-05-20.09_09_04_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'Dubins10MPSWindSouth32014-05-20.09_02_47_latlon_.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    legend([h4 h5], 'Start', 'End', 'Location','best');
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Augmented Dubins Path with 10 m/s wind (south)')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\DubinsGeoPos_wind_10.eps');
    
%% Straight Line Approach wind = 0 m/s
figure

    filename = 'StraightLineNoWind12014-05-20.08_23_34_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'StraightLineNoWind22014-05-20.08_26_19_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'StraightLineNoWind32014-05-20.08_29_03_latlon_.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    axis image
    
    legend([h4 h5], 'Start', 'End', 'Location','best');
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Straight Line Approach without wind')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\SLA_GeoPos_wind_0.eps');
    
%% Straight Line Approach wind = 5 m/s
figure

    filename = 'StraightLine5MPSWindSouth12014-05-20.08_38_44_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'StraightLine5MPSWindSouth22014-05-20.08_42_06_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'StraightLine5MPSWindSouth32014-05-20.08_45_58_latlon_.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    legend([h4 h5], 'Start', 'End', 'Location','best');
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Straight Line Approach with 5 m/s wind (south)')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\SLA_GeoPos_wind_5.eps');
    
%% Straight Line Approach wind = 10 m/s
figure

    filename = 'StraightLine10MPSWindSouth12014-05-20.09_15_15_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'StraightLine10MPSWindSouth22014-05-20.09_17_32_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    filename = 'StraightLine10MPSWindSouth32014-05-20.09_19_29_latlon_.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    legend([h4 h5], 'Start', 'End', 'Location','best');
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Straight Line Approach with 10 m/s wind (south)')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\SLA_GeoPos_wind_10.eps');