clear all;
close all;
clc;

format long;

% Set path
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\Log\WindTest')
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\')
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\Log\WindTest2')

% Hardcoded target position as observed in HIL
target_pos = [0.657082 -2.135650]/pi*180;


%% Dubins Path wind = 0 m/s
figure

    % Hardcoded release position as observed in HIL
    rel_pos = [0.657096 -2.135650]/pi*180;

    filename = 'DubinsNoWind12014-05-20.08_13_29_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'DubinsNoWind22014-05-20.08_16_51_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'DubinsNoWind32014-05-20.08_19_35_latlon_.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    h_r = plot(rel_pos(2), rel_pos(1), 'ok', 'LineWidth', 2);
   
    legend([h4 h5 h_r], 'Start', 'End', 'CARP', 'Location','Best')
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Augmented Dubins Path without wind')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
%     axis('square')
%    axis([-122.368 -122.358 37.642 37.658])

    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\DubinsGeoPos_wind_0.eps');

    
%% Dubins Path wind = 5 m/s
figure

    % Hardcoded release position as observed in HIL
    rel_pos = [0.657090 -2.135650]/pi*180;

    filename = 'Dubins5MPSWindSouth12014-06-04.18_19_50_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'Dubins5MPSWindSouth22014-06-04.18_22_53_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    filename = 'Dubins5MPSWindSouth32014-06-04.18_25_29_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);
    
    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    h_r = plot(rel_pos(2), rel_pos(1), 'ok', 'LineWidth', 2);
    
    %h_t = plot(target_pos(2), target_pos(1), 'xk', 'LineWidth', 2);
    
    %axis equal
    
    legend([h4 h5 h_r], 'Start', 'End', 'CARP', 'Location','Best')
    
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Augmented Dubins Path with 5 m/s wind (south)')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\DubinsGeoPos_wind_5.eps');


%% Dubins Path wind = 10 m/s
figure

    % Hardcoded release position as observed in HIL
    rel_pos = [0.657083 -2.135650]/pi*180;

    filename = 'Dubins10MPSWindSouth12014-05-20.09_05_11_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'Dubins10MPSWindSouth22014-05-20.09_09_04_latlon_.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = 'Dubins10MPSWindSouth32014-05-20.09_02_47_latlon_.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    h_r = plot(rel_pos(2), rel_pos(1), 'ok', 'LineWidth', 2);
    
    legend([h4 h5 h_r], 'Start', 'End', 'CARP', 'Location','Best')    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Augmented Dubins Path with 10 m/s wind (south)')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))

    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\DubinsGeoPos_wind_10.eps');
    
%% Straight Line Approach wind = 0 m/s
figure

    % Hardcoded release position as observed in HIL
    rel_pos = [0.657096 -2.135650]/pi*180;

    filename = '2014-06-03.16_19_16_latlon_wind0.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = '2014-06-03.16_21_26_latlon_wind0.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = '2014-06-03.16_25_57_latlon_wind0.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    h_r = plot(rel_pos(2), rel_pos(1), 'ok', 'LineWidth', 2);
    
    
    legend([h4 h5 h_r], 'Start', 'End', 'CARP', 'Location','Best')
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Straight Line Approach without wind')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\SLA_GeoPos_wind_0.eps');
    
%% Straight Line Approach wind = 5 m/s
figure

    % Hardcoded release position as observed in HIL
    rel_pos = [0.657090 -2.135650]/pi*180;

    filename = '2014-06-03.16_30_04_latlon_wind5.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = '2014-06-03.16_32_13_latlon_wind5.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = '2014-06-03.16_34_42_latlon_wind5.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    h_r = plot(rel_pos(2), rel_pos(1), 'ok', 'LineWidth', 2);
    
   
    legend([h4 h5 h_r], 'Start', 'End', 'CARP', 'Location','Best')
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Straight Line Approach with 5 m/s wind (south)')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\SLA_GeoPos_wind_5.eps');
    
%% Straight Line Approach wind = 10 m/s
figure

    % Hardcoded release position as observed in HIL
    rel_pos = [0.657083 -2.135650]/pi*180;

    filename = '2014-06-03.16_38_30_latlon_wind10.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h1 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':b', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;

    filename = '2014-06-03.16_40_27_latlon_wind10.txt';
    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h2 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':r', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    filename = '2014-06-03.16_42_53_latlon_wind10.txt';

    dubins_wind_0 = extractGeoPosition(filename);

    dubins_wind_0(:,1) = dubins_wind_0(:,1)/pi*180;
    dubins_wind_0(:,2) = dubins_wind_0(:,2)/pi*180;

    h3 = plot(dubins_wind_0(:,2), dubins_wind_0(:,1), ':g', 'LineWidth', 2);
    hold on;
    h4 = plot(dubins_wind_0(1,2), dubins_wind_0(1,1), 'dk', 'LineWidth', 2);
    hold on;
    h5 = plot(dubins_wind_0(end,2), dubins_wind_0(end,1), 'sk', 'LineWidth', 2);
    hold on;
    
    h_r = plot(rel_pos(2), rel_pos(1), 'ok', 'LineWidth', 2);
   
    legend([h4 h5 h_r], 'Start', 'End', 'CARP', 'Location','Best')
    
    xlabel('Longitude')
    ylabel('Latitude')
    title('Straight Line Approach with 10 m/s wind (south)')
    set(gca, 'XTickLabel', get(gca,'XTick'))
    rotateXLabels( gca(), 45)
%     set(gca, 'YTickLabel', num2str(get(gca,'YTick')','%f'))
    
    % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\SLA_GeoPos_wind_10.eps');