clear all;
close all;
clc;

format long;

% Set path
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\Log\HalfplaneVSBall')
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\')

% Extract first file
filename = '2014-05-15.14_20_22_dist_.txt';
[ data_HP, data_B ] = extractDistHPvsB(filename);

n_HP_first = length(data_HP);
% Extract second file
filename = '2014-05-16.08_25_35_dist_.txt';
[ temp_data_HP, temp_data_B ] = extractDistHPvsB(filename);

% Merge data
data_HP = [temp_data_HP];%[data_HP; temp_data_HP];
%data_B = [data_B; temp_data_B];

% Create sample vectors
n_HP = length(data_HP);
n_HP2 = length(temp_data_HP);
n_B = length(data_B);
n_HP_v = 1:n_HP;
n_B_v = 1:n_B;
n_B2 = length(temp_data_B);
n_B2_v = 1:n_B2;


%% Plot
figure
    
    subplot(3,1,1)
        h1 = plot(n_HP_v, data_HP(:,2),'LineWidth', 2);
        title(sprintf('Distance from CARP with Halfplane criteria'))
        ylabel('x [m]')
    subplot(3,1,2)
        h1 = plot(n_HP_v, data_HP(:,3),'LineWidth', 2);
        ylabel('y [m]')
    subplot(3,1,3)
        h1 = plot(n_HP_v, data_HP(:,1),'LineWidth', 2);
        ylabel(sprintf('Total horizontal \n distance [m]'))
        xlabel('Logged Samples')
        % Save as .eps
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\Halfplane_testing.eps');

        
% figure
%     
%     subplot(3,1,1)
%         h1 = plot(n_B_v, data_B(:,2),'LineWidth', 2);
%         title(sprintf('Distance from PoI with Ball criteria R = 30 m'))
%         ylabel('Distance in x')
%     subplot(3,1,2)
%         h1 = plot(n_B_v, data_B(:,3),'LineWidth', 2);
%         ylabel('Distance in y')
%     subplot(3,1,3)
%         h1 = plot(n_B_v, data_B(:,1),'LineWidth', 2);
%         ylabel(sprintf('Total horizontal \n distance'))
        

    
figure
    
    subplot(3,1,1)
        h1 = plot(n_B2_v, temp_data_B(:,2),'LineWidth', 2);
        title(sprintf('Distance from CARP with Circle criteria R = 10m'))
        ylabel('x [m]')
    subplot(3,1,2)
        h1 = plot(n_B2_v, temp_data_B(:,3),'LineWidth', 2);
        ylabel('y [m]')
    subplot(3,1,3)
        h1 = plot(n_B2_v, temp_data_B(:,1),'LineWidth', 2);
        ylabel(sprintf('Total horizontal \n distance [m]'))
        xlabel('Logged Samples')
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\Ball_testing.eps');

        
% figure
%     minData = [];
%     for i = n_B_v
%         if( i == 1 || i == length(n_B_v)+1 )
%             
%         else
%             if( data_B(i,1) < data_B(i-1,1) && data_B(i,1) < data_B(i+1,1) )
%             minData = [minData data_B(i,1)];
%             end
%         end
%         
%     end
%     n_min = 1:length(minData);
%     plot(n_min, minData(:), 'Linewidth', 2);
%     title('Radius = 30 m, IAS = 28 m/s');
%     xlabel('Samples');
%     ylabel('Smallest distance from target [m]');
    
    
    
figure
    minData = [];
    for i = n_B2_v
        if( i == 1 || i == length(n_B2_v)+1 )
            
        else
            if( temp_data_B(i,1) < temp_data_B(i-1,1) && temp_data_B(i,1) < temp_data_B(i+1,1) )
            minData = [minData temp_data_B(i,1)];
            end
        end
        
    end
    n_min = 1:length(minData);
    plot(n_min, minData(:), 'Linewidth', 2);
    title('Smallest distance from CARP with Circle criteria R = 10m');
    xlabel('Logged Samples');
    ylabel('Total horizontal distance [m]');

    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\Ball_testing_smallest.eps');

        
