clear all;
close all;
clc;

format long;

% Set path
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\Log\StraightLineApproach')
path(path, 'C:\Users\simenfu\Dropbox\Master Thesis\Matlab\')

% Extract file
filename = '2014-05-18.19_18_32_deviation_.txt';
data = extractDist( filename );

% Create sample vector
n = 1:length(data);

direction = zeros(length(data),1);
speed = zeros(length(data),1);

for i = n
    speed(i) = sqrt(data(i,5)^2 + data(i,6)^2 + data(i,7)^2);
    direction(i) = atan(data(i,6)/data(i,5))-atan(data(i,9)/data(i,8));
    direction(i) = direction(i)/pi*180;
end
    


%% Plot Dubins Path long time test

% Distance
figure
    
    subplot(3,1,1)
        h1 = plot(n, data(:,1),'LineWidth', 2);
        title(sprintf('Distance from PoR'))
        ylabel('x [m]')
    subplot(3,1,2)
        h1 = plot(n, data(:,2),'LineWidth', 2);
        ylabel('y [m]')
    subplot(3,1,3)
        h1 = plot(n, data(:,4),'LineWidth', 2);
        ylabel(sprintf('Total horizontal\ndistance [m]'))
        xlabel('Logged Samples')
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\Approach_configuration_SLA_Distance.eps');


% Direction
[muhat,sigmahat] = normfit(direction);

Y = normpdf(6.2:0.01:7.2, muhat, sigmahat );

figure
    plot(6.2:0.01:7.2, Y, 'LineWidth', 2)
    title('Estimated Normal Distribution of the deviation from the desired angle')
    xlabel('Angle [deg]')
    ylabel('Probability density, p(Angle)')
    text(6.9,10,'$\hat{\mu}$','Interpreter','latex')
    text(6.93,10,sprintf('= %f', muhat))
    text(6.9,9.5,'$\hat{\sigma}$','Interpreter','latex')
    text(6.93,9.5,sprintf('= %f', sigmahat))
    set(gcf,'color','w');
    export_fig ('C:\Users\simenfu\Dropbox\Master Thesis\Thesis\Approach_configuration_SLA_Direction.eps');


figure
    plot(n, direction(:),'LineWidth', 2)
    xlabel('Samples')
    ylabel('Angle [deg]')
    title('Deviation from desired angle')
    
% Speed
% figure
%     plot(n, speed(:),'LineWidth', 2)