function data = extractDist( filename )

    % Create a file ID for the text file
    %filename = 'Log/StraightLineApproach/2014-05-18.19_18_32_deviation_.txt';

    fileID = fopen(filename);

    % Read data from file
    % distX distY distZ distTot velX velY velZ idealVelX idealVelY idealVelZ
    %data = textscan(fileID, '%f', ...
    %    'Delimiter', '\t');%, 'CollectOutput', 1);

    T = readtable(filename, 'HeaderLines', 1, 'Delimiter', '\t');

    % Delete headers
    T([1:13],:) = [];

    tab_len = length(T.method(:));
    samples = (tab_len-1)/12;

    data = zeros(samples, 10);

    counter = 1;
    
    for i=1:12:tab_len-1
        for j=2:12
            if strcmp(T.method(i+j), 'halfplane')
                %disp('Fant halfplane')
            elseif strcmp(T.method(i+j), '-------------------------')
                %disp('Fant en strek')
            else
                data(counter,j-1) = str2double(T.method(i+j));
            end
        end
        counter = counter + 1;
    end

    % Close file
    fclose(fileID);
    
end