function [ data_halfplane, data_ball ] = extractDistHPvsB( filename )

    %filename = 'Log/HalfplaneVSBall/2014-05-15.14_20_22_dist_.txt';


    fileID = fopen(filename);

    % Read data from file
    % distX distY distZ distTot velX velY velZ idealVelX idealVelY idealVelZ
    %data = textscan(fileID, '%f', ...
    %    'Delimiter', '\t');%, 'CollectOutput', 1);

    T = readtable(filename, 'HeaderLines', 1, 'Delimiter', '\t');
    
    T([1],:) = [];

    tab_len = length(T.method(:));
    samples = (tab_len)/4;
    
    n_HP = 0;
    n_B = 0;
    
    % Count halfplanes and ball samples
    for i=1:tab_len
        if strcmp(T.method(i), 'halfplane')
            n_HP = n_HP + 1;
        elseif strcmp(T.method(i), 'ball')
            n_B = n_B + 1;
        end
    end

    
    data_halfplane = zeros(n_HP, 3);
    data_ball = zeros(n_B, 3);
    
    countHP = 1;
    countB = 1;
    
    for i=1:4:tab_len-1
        if strcmp(T.method(i), 'halfplane')
            for j=1:3
                data_halfplane(countHP,j) = str2double(T.method(i+j));
            end
            countHP = countHP + 1;
        elseif strcmp(T.method(i), 'ball')
            for j=1:3
                data_ball(countB,j) = str2double(T.method(i+j));
            end
            countB = countB + 1;
        end
    end

    % Close file
    fclose(fileID);
    
end