
b_phi = 1;

g = 9.81;
v = 28;
v_w = [0 -2]';
dest = [0 0]';

iter = 0;
new_wp_path = true;

tstart = 0;
tend = 0.1;
tspan = [tstart tstart+tend];

max_roll = pi/6;
max_phi_dot = g/v*tan(max_roll);
max_turn_radius = v^2/(g*tan(max_roll));

% Path to follow
r = dest;
q = -(v_w/norm(v_w));

% Initial position and heading
x_init = [-400 500 0.0]';

p = [x_init(1) x_init(2)]';

% Generate simple WP list
wp = generateWPList(dest, q, max_turn_radius, p);

phi_dot = 0;
tRes = [];
xRes = [];

for i = 1:1000

    [t, x] = ode45(@(t,x) fun(t,x,v,phi_dot), tspan, x_init);


    tLen = length(t);
    
    if isempty(tRes)
        tRes = t';
    else
        tRes = [tRes t'];
    end
    
    if isempty(xRes)
        xRes = x';
    else
        xRes = [xRes x'];
    end

    % Set final states of last iteration to first states of next
    x_init = x(tLen,:)';
    tstart = tstart + tend;
    tspan = [tstart tstart+tend];
    
    p = [x_init(1) x_init(2)]';
    phi = x_init(3);
    
    [new_wp_path, r, q_prev, iter] = simpleFollowWP(new_wp_path, wp, p , iter);
    
    phi_c = followStraightLine(r, q_prev, p, phi);
    
    phi_dot = b_phi*(phi_c - phi);
    
    if phi_dot > max_phi_dot
        phi_dot = max_phi_dot;
    elseif phi_dot < -max_phi_dot
        phi_dot = -max_phi_dot;
    end
    
%     p = [x(1) x(2)];
%     chi = x(3);
%     
%     chi_c = followStraightLine(r, q, p, chi);
%     
%     phi_dot = 
%     

    
end